package router;

import java.util.Arrays;

public class IPAddress {

    private int[] data;

    public IPAddress(int[] address) {
        data = Arrays.copyOf(address, address.length);
    }
    
    public static IPAddress fromString(String ipstr) {
        String[] strs = ipstr.split("\\.");
	int[] ints = new int[strs.length];
	for (int i=0; i < strs.length; i++) {
	    ints[i] = Integer.parseInt(strs[i]);
	}
	return new IPAddress(ints);
    }

    public boolean isTheSame(IPAddress otherIP) {
        return Arrays.equals(data, otherIP.data);
    }

    // az aktualis nagyobb vagy egyenlo a parameterben kapottnal
    private boolean greaterOrEquals(IPAddress ip2) {
	for (int i=0; i < data.length; i++) {
	    if (data[i] > ip2.data[i]) return true;
	    if (data[i] < ip2.data[i]) return false;
	}
	return true;
    }
    
    public boolean insideRng(IPAddress lowBound, IPAddress highBound) {
        return this.greaterOrEquals(lowBound) &&
	    highBound.greaterOrEquals(this);
    }

    public String toString() {
        String s = "";
	for (int i=0; i < data.length - 1; i++) {
	    s += data[i] + ".";
	}
	s += data[data.length-1];
	return s;
	//return String.join(data, "."); //1.8-as Javatol
    }
}
