package router;

import java.util.List;
import java.util.LinkedList;

public class Packet {
    private static final int INIT_TTL = 50;

    private String data;
    private IPAddress destination;
    private int ttl = INIT_TTL;
    private List<IPAddress> path = new LinkedList<IPAddress>();
    
    public Packet(String data, IPAddress destination) {
        this.data = data;
        this.destination = destination;
    }
    
    public IPAddress getDestination() {
        return destination;
    }

    public void recordPath(IPAddress currLoc) {
        path.add(currLoc);
        ttl = ttl - 1;
    }
    
    public boolean isLive() {
        return ttl > 0;
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        for ( IPAddress ip : path ) {
            sb.append(ip.toString()).append(" , ");
        }
        sb.append(data);
        return sb.toString();
    }
}
